Solid Example: CreateBatcher

import { For, createSignal } from 'solid-js'
import { render } from 'solid-js/web'
import { createBatcher } from '@tanstack/solid-pacer/batcher'

function App1() {
  const [processedBatches, setProcessedBatches] = createSignal<
    Array<Array<number>>
  >([])

  // Create the batcher instance
  const batcher = createBatcher(
    (items: Array<number>) => {
      setProcessedBatches((prev) => [...prev, items])
      console.log('Processing batch', items)
    },
    {
      maxSize: 5,
      wait: 3000,
      getShouldExecute: (items) => items.includes(42),
    },
    // Alternative to batcher.Subscribe: pass a selector as 3rd arg to track state and subscribe to updates
    // (state) => state,
  )

  return (
    <div>
      <h1>TanStack Pacer createBatcher Example 1</h1>
      <batcher.Subscribe
        selector={(state) => ({
          size: state.size,
          items: state.items,
          executionCount: state.executionCount,
          totalItemsProcessed: state.totalItemsProcessed,
        })}
      >
        {(state) => (
          <>
            <div>Batch Size: {state().size}</div>
            <div>Batch Max Size: {5}</div>
            <div>Batch Items: {state().items.join(', ')}</div>
            <div>Batches Processed: {state().executionCount}</div>
            <div>Items Processed: {state().totalItemsProcessed}</div>
            <div>
              Processed Batches:{' '}
              <For each={processedBatches()}>
                {(b) => <span>[{b.join(', ')}], </span>}
              </For>
            </div>
            <div
              style={{
                display: 'grid',
                'grid-template-columns': 'repeat(2, 1fr)',
                gap: '8px',
                'max-width': '600px',
                margin: '16px 0',
              }}
            >
              <button
                onClick={() => {
                  const nextNumber = state().items.length
                    ? state().items[state().items.length - 1] + 1
                    : 1
                  batcher.addItem(nextNumber)
                }}
              >
                Add Number
              </button>
              <button
                disabled={state().size === 0}
                onClick={() => {
                  batcher.flush()
                }}
              >
                Process Current Batch
              </button>
            </div>
          </>
        )}
      </batcher.Subscribe>
      <batcher.Subscribe selector={(state) => state}>
        {(state) => (
          <pre style={{ 'margin-top': '20px' }}>
            {JSON.stringify(state, null, 2)}
          </pre>
        )}
      </batcher.Subscribe>
    </div>
  )
}

render(
  () => (
    <div>
      <App1 />
    </div>
  ),
  document.getElementById('root')!,
)
import { For, createSignal } from 'solid-js'
import { render } from 'solid-js/web'
import { createBatcher } from '@tanstack/solid-pacer/batcher'

function App1() {
  const [processedBatches, setProcessedBatches] = createSignal<
    Array<Array<number>>
  >([])

  // Create the batcher instance
  const batcher = createBatcher(
    (items: Array<number>) => {
      setProcessedBatches((prev) => [...prev, items])
      console.log('Processing batch', items)
    },
    {
      maxSize: 5,
      wait: 3000,
      getShouldExecute: (items) => items.includes(42),
    },
    // Alternative to batcher.Subscribe: pass a selector as 3rd arg to track state and subscribe to updates
    // (state) => state,
  )

  return (
    <div>
      <h1>TanStack Pacer createBatcher Example 1</h1>
      <batcher.Subscribe
        selector={(state) => ({
          size: state.size,
          items: state.items,
          executionCount: state.executionCount,
          totalItemsProcessed: state.totalItemsProcessed,
        })}
      >
        {(state) => (
          <>
            <div>Batch Size: {state().size}</div>
            <div>Batch Max Size: {5}</div>
            <div>Batch Items: {state().items.join(', ')}</div>
            <div>Batches Processed: {state().executionCount}</div>
            <div>Items Processed: {state().totalItemsProcessed}</div>
            <div>
              Processed Batches:{' '}
              <For each={processedBatches()}>
                {(b) => <span>[{b.join(', ')}], </span>}
              </For>
            </div>
            <div
              style={{
                display: 'grid',
                'grid-template-columns': 'repeat(2, 1fr)',
                gap: '8px',
                'max-width': '600px',
                margin: '16px 0',
              }}
            >
              <button
                onClick={() => {
                  const nextNumber = state().items.length
                    ? state().items[state().items.length - 1] + 1
                    : 1
                  batcher.addItem(nextNumber)
                }}
              >
                Add Number
              </button>
              <button
                disabled={state().size === 0}
                onClick={() => {
                  batcher.flush()
                }}
              >
                Process Current Batch
              </button>
            </div>
          </>
        )}
      </batcher.Subscribe>
      <batcher.Subscribe selector={(state) => state}>
        {(state) => (
          <pre style={{ 'margin-top': '20px' }}>
            {JSON.stringify(state, null, 2)}
          </pre>
        )}
      </batcher.Subscribe>
    </div>
  )
}

render(
  () => (
    <div>
      <App1 />
    </div>
  ),
  document.getElementById('root')!,
)

TanStack

Svelte Example: CreateBatcher

<script lang="ts">
  import { TanStackDevtools } from '@tanstack/svelte-devtools'
  import { pacerDevtoolsPlugin } from '@tanstack/svelte-pacer-devtools'
  import { createBatcher } from '@tanstack/svelte-pacer/batcher'

  let processedBatches = $state<Array<Array<number>>>([])

  // The function that will process a batch of items
  function processBatch(items: Array<number>) {
    processedBatches = [...processedBatches, items]
    console.log('processing batch', items)
  }

  const batcher = createBatcher(processBatch, () => ({
    key: 'createBatcher',
    // started: false, // true by default
    maxSize: 5, // Process in batches of 5 (if comes before wait time)
    wait: 3000, // wait up to 3 seconds before processing a batch (if time elapses before maxSize is reached)
    getShouldExecute: (items, _batcher) => items.includes(42), // or pass in a custom function to determine if the batch should be processed
  }))
</script>

<div>
  <div>
    <h1>TanStack Pacer createBatcher Example 1</h1>
    <batcher.Subscribe
      selector={(state) => ({
        size: state.size,
        items: state.items,
        executionCount: state.executionCount,
        totalItemsProcessed: state.totalItemsProcessed,
      })}
      >{#snippet children({
        size,
        items,
        executionCount,
        totalItemsProcessed,
      })}<div>
          Batch Size: {size}
        </div>
        <div>Batch Max Size: {5}</div>
        <div>Batch Items: {items.join(', ')}</div>
        <div>Batches Processed: {executionCount}</div>
        <div>Items Processed: {totalItemsProcessed}</div>
        <div>
          Processed Batches:{' '}{#each processedBatches as b, i (i)}<span
              >[{b.join(', ')}]</span
            >,{' '}{/each}
        </div>
        <div
          style="display: grid; grid-template-columns: repeat(2, 1fr); gap: 8px; max-width: 600px; margin: 16px 0"
        >
          <button
            onclick={() => {
              const nextNumber = batcher.peekAllItems().length
                ? batcher.peekAllItems()[batcher.peekAllItems().length - 1]! + 1
                : 1
              batcher.addItem(nextNumber)
            }}
          >
            Add Number</button
          ><button
            disabled={size === 0}
            onclick={() => {
              batcher.flush()
            }}
          >
            Flush Current Batch
          </button>
        </div>{/snippet}</batcher.Subscribe
    ><batcher.Subscribe selector={(state) => state}
      >{#snippet children(state)}<pre style="margin-top: 20px">{JSON.stringify(
            state,
            null,
            2,
          )}</pre>{/snippet}</batcher.Subscribe
    >
  </div>
  <hr />
</div>
{#if import.meta.env.DEV}<TanStackDevtools
    plugins={[pacerDevtoolsPlugin()]}
  />{/if}